unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, TeEngine, Series, TeeProcs, Chart, tineclient, tinetypes, tinedefs;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TFastLineSeries;
    CycleTimer: TTimer;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure InitTineLink();
    procedure CycleTimerTimer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;
const
  BUFFER_LEN = 2000;
var
  Form1: TForm1;
  FloatBuf: array[0 .. (BUFFER_LEN - 1)] of single;   // 4 byte float
  databuf : array[0 .. (BUFFER_LEN - 1)] of double;   // 8 byte float used by TChart
  WaveformId: integer;

procedure TineCallback(linkId:integer; completionCode: integer); cdecl;

implementation

{$R *.DFM}

procedure TineCallback(linkId:integer; completionCode: integer); cdecl;
var index:integer;
begin
  if (completionCode <> 0) then
    begin
    ShowMessage('TRC error: ' +GetLastLinkErrorAsString(completionCode));
    Form1.CycleTimer.Enabled:=false;
    end;
  if linkId = WaveformId then
       begin
       Form1.Chart1.SeriesList.Series[0].Clear;
       { TChart accepts only array of double. }
       for index:=0 to (BUFFER_LEN - 1) do
          databuf[index]:=FloatBuf[index];
       Form1.Chart1.SeriesList.Series[0].AddArray(databuf);
       end;
end; 

procedure TForm1.CycleTimerTimer(Sender: TObject);
var retry:boolean;
begin
  { SystemCycle needs to be called regularly. If the return value is true,
    SystemCycle should be called immediately again. }
  retry:=true;
  while retry do
    retry:=SystemCycle(true);
end;

procedure TForm1.InitTineLink();
var dout : DTYPE;
    DeviceName   : array[0 .. (DEVICE_NAME_SIZE-1)] of char;
    PropertyName : array[0 .. (PROPERTY_NAME_SIZE-1)] of char;
begin
  { initialize an asynchronous link to an array of 2000 4-byte float.
    if data has arrived, the procedure TineCallback is called. }
  StrPCopy(@DeviceName, 'MTF.RF/MODDATA/KLYMOD2');
  StrPCopy(@PropertyName, 'V_OUT.WAVEFORM');
  dout.dArrayLength := BUFFER_LEN;
  dout.dFormat      := CF_FLOAT;
  dout.data.fptr    := @FloatBuf[0];
  WaveformId := AttachLink(@DeviceName, @PropertyName, @dout, NIL, CA_READ, 1000, @TineCallback, CM_POLL);
  if (WaveformId < 0) then
     ShowMessage('ERROR initializing tine link: "'+GetLastLinkErrorAsString(WaveformId)+'"')
  else
     { start calling SystemCycle periodically }
     CycleTimer.Enabled:=true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InitializeTineclientDll('C:\TINE\system32');
  InitTineLink();
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  case Action of
     caFree:
        begin
        Form1.CycleTimer.Enabled:=false;
        sleep(2*Form1.CycleTimer.Interval);
        UnInitializeTineclientDll();
        end
      else ; { caNone, caHide, caMinimize: do nothing }
  end;
end;

end.
